#define MAIN
/*@unused@*/
static char *getmsg_c_rcs_id = "$Header: /diskb/home/alexis/dev/supported/ppplc/bin/RCS/getmsg.c,v 1.6 1999/05/07 14:27:37 alexis Exp $";

/*******************************************************************************
*
*   System Includes
* 
*******************************************************************************/

#include <sys/types.h>			/* for time_t */
#include <stdio.h>			/* for printf and NULL */
#include <string.h> 			/* for strrchr(),strtok(),strerror() */
#include <signal.h>			/* for SIGINT, SIG_IGN etc */
#include <errno.h>			/* for errno in strerror() */
#include <stdlib.h>			/* for exit() */

/*******************************************************************************
*
*   Application Includes
* 
*******************************************************************************/

#include "utils.h"			
#include "patchlevel.h"
#include "ppplc_msgids.h"		/* for MSGID_* */
#include "sm.h"				/* for smf_*() */
#include "ppplc.h"			/* for MSGTO_* */

/*******************************************************************************
*
*   Symbol Definitions
* 
*******************************************************************************/

/*******************************************************************************
*
*   Structure Definitions
* 
*******************************************************************************/

/*******************************************************************************
*
*   Static Functions Forward Declarations
*   
*******************************************************************************/

static void sigintterm_handler(int);
static int process_info_message(int *);
static int usage(void);

/*******************************************************************************
*
*   Static Data Definitions
*   
*******************************************************************************/

static struct mhflkuprec getmsg_mhf_data[] = {
	    { MSGID_INFO_DATA,              process_info_message            },
	    { MSGID_PSEUDO_LAST,            NULL                            }

};

/*******************************************************************************
*
*   Global Data Definitions
*   
*******************************************************************************/

/*******************************************************************************
*
*   Functions: main() and usage() and gen_lockfile_name()
*   
*******************************************************************************/

static int usage()
{
    debug(DBG_FUNCS, "usage: sof");

    fprintf(stderr, "Usage: %s [ -d <level> ]\n", progname);
    exit(EXIT_FAILURE);
}

main(
int argc,
char *argv[])
{
    progname = mybasename(argv[0], "");
    while (argc>1 && argv[1][0] == '-') {
        if (strcmp(argv[1], "-V") ==0) {
            printf("%s version %s\n", progname, patchlevel);
            exit(EXIT_SUCCESS);

        } else if (strcmp(argv[1], "-d") == 0) {
            (argc<3) && usage();
            (sscanf(argv[2], "%lu", &debug_level)!=1) && usage();
            argc--; argv++;

        } else 
            (void) usage();

        argv++;
        argc--;
    }
    
    (argc != 1) && usage();

    debug(DBG_FUNCS, "main: sof (proper)");
    debug(DBG_SIGEXEC, "main: setting up signal handlers");
    signal(SIGINT, sigintterm_handler);
    signal(SIGTERM, sigintterm_handler);

    if (smf_init(SMS_MCMODE_CLIENT, NULL, NULL) != 0)
        error("initialisation of client-mode state machine failed");
    
    if (smf_engine(MSGTO_GETMSG, svrmsginfo_data, getmsg_mhf_data) != 0) 
	error("state machine error");

    return(0);
}

static void sigintterm_handler(
/*@unused@*/
int signumber)
{
    debug(DBG_FUNCS, "sigint_handler: sof");
    info("exiting on SIGINT/SIGTERM");
    exit(EXIT_FAILURE);
}

static int process_info_message(
int *parp)
{
    int i, parc;

    debug(DBG_FUNCS, "process_info_message: sof");
    
    /*
     *  This function is to handle data dump messages only, but since the
     *  number of numbers returned in the parameter block changes as I 
     *  develop this program, it is more resiliant to actually look this
     *  number up each time, rather than wind up shooting over the end of
     *  the array, or not reading to the end of it.
     */

    for (i=0,parc=svrmsginfo_data[smf_msginfo(svrmsginfo_data, MSGID_INFO_DATA)].argc; i<parc; i++)
        printf("%d ", *(parp+i));
    printf("\n");
    
    /* 
     *  Give the state machine permission to exit when we return from *this*
     *  function, or it'll never return!
     */

    smf_setquit(SMS_VAR_TOGGLE);

    return(0);
}
