/*@unused@*/
static char *ppplcd_c_rcs_id = "$Header: /home/ahuxley/dev/supported/ppplc/bin/RCS/ppplcd.c,v 1.25 2000/01/09 10:59:50 ahuxley Exp $";

/*******************************************************************************
*
*   System Includes
* 
*******************************************************************************/

#include <sys/types.h>
#include <stdio.h>				/* for NULL */
#include <string.h> 				/* for strrchr(), strtok() */
#include <signal.h>				/* for SIGINT, SIG_IGN etc */
#include <sys/wait.h>				/* for wait() par types */
#include <sys/time.h>				/* for time() */
#include <unistd.h>				/* for setpgrp() */
#include <errno.h>				/* for errno in strerror() */
#include <stdlib.h>				/* for exit() */
#include <stdarg.h>				/* for va_lists */
#include <stdlib.h>				/* for calloc(), atoi() */
#include <pwd.h>				/* for getpwnam() */
#include <grp.h>				/* for getgrnam() */
#include <sys/stat.h>				/* for umask() */

/*******************************************************************************
*
*   Application Includes
* 
*******************************************************************************/

#include "utils.h"			/* for mybasename() and error fncs */
#include "ppplc.h"			/* for c queue definitions */
#include "patchlevel.h"
#include "sm.h"
#include "ppplc_msgids.h"			/* for message ids */

/*******************************************************************************
*
*   Symbol Definitions
* 
*******************************************************************************/

#define HUPID_UNSET			-1
#define HUPID_QUALITY  			1
#define HUPID_IDLE    			2
#define HUPID_HANGUP  			3	

#define ANNID_UP			0
#define ANNID_DOWN_QUALITY_REDIAL	1
#define ANNID_DOWN_QUALITY_NOREDIAL 	2
#define ANNID_DOWN_REMOTE_REDIAL	3
#define ANNID_DOWN_REMOTE_NOREDIAL 	4
#define ANNID_DOWN_IDLE_NOREDIAL	5
#define ANNID_DOWN_HANGUP_NOREDIAL	6

#define IFNO_UNSET			-1
#define INFID_RESERVED			-1000
#define PPPD_LOCK_FILE_FMTSTR  		"/var/run/ppp%d.pid"
#define PPPLCD_MAXSTRLEN                256

#define KW_COMMAND_UNIX_PPPD 	       "command-unix-pppd"
#define KW_COMMAND_UNIX_CHAT 	       "command-unix-chat"
#define KW_COMMAND_PPPLCD_ANNOUNCE     "command-ppplcd-announce"
#define KW_COMMAND_PPPLCD_WANNABECHANGED "command-ppplcd-wannabechanged"
#define KW_SETTING_PPPD_DEBUG          "setting-pppd-debug"
#define KW_SETTING_PPPD_KDEBUG         "setting-pppd-kdebug"
#define KW_INCLUDE 		       "include"
#define KW_SETTING_MISC_TIMEOUT_IDLE   "setting-misc-timeout-idle"
#define KW_COMMAND_PPPLCD_QUALITYTEST  "command-ppplcd-qualitytest"
#define KW_COMMAND_PPPLCD_USECOUNT     "command-ppplcd-usecount"
#define KW_COMMAND_PPPLCD_XFER_NEWS    "command-ppplcd-xfer-news"
#define KW_COMMAND_PPPLCD_XFER_MAIL    "command-ppplcd-xfer-mail"
#define KW_SETTING_CONNECT_LOGIN       "setting-connect-login"
#define KW_SETTING_CONNECT_PASSWORD    "setting-connect-password"
#define KW_SETTING_CONNECT_PHONENUMBER "setting-connect-phonenumber"
#define KW_SETTING_MISC_AUTORECONNECT  "setting-misc-autoreconnect"
#define KW_SETTING_IP_NETMASK          "setting-ip-netmask"
#define KW_SETTING_IP_MTU              "setting-ip-mtu"
#define KW_SETTING_IP_MRU              "setting-ip-mru"
#define KW_SETTING_IPC_MODE            "setting-ipc-mode"
#define KW_SETTING_IPC_OWNER           "setting-ipc-owner"
#define KW_SETTING_IPC_GROUP           "setting-ipc-group"
#define KW_SETTING_DEVICE_MODEM_DEVICE "setting-device-modem-device"
#define KW_SETTING_DEVICE_MODEM_SPEED  "setting-device-modem-speed"
#define KW_SETTING_MISC_QUALITY        "setting-misc-quality"
#define KW_CHATLINE                    "chatline"
#define KW_COMMAND_PPPLCD_MISC         "command-ppplcd-misc"
#define KW_ASSIGN                      "assign"
#define KWN_UNSET			-1	/* unset numeric keyword */

/*******************************************************************************
*
*   Structure Definitions
* 
*******************************************************************************/

struct strchnrec {				/* generic string chain */
    char *str;					/* the string */
    struct strchnrec *nxt;			/* the link */
};

/*******************************************************************************
*
*   Static Functions Forward Declarations
*   
*******************************************************************************/

static int gen_lockfile_name(char *, char *);
static void sigchld_handler(int);
static void sigterm_handler(int);
static int ipup_part1(void);
static int ipup_part2(void);
static int ipup_part3(void);
static int ipup_part4(void);
static int mhf_load_config(int *);
static int mhf_gen_config(int *);
static int mhf_set_autoreconnect(int *);
static int mhf_unset_autoreconnect(int *);
static int mhf_info_request(int *);
static int mhf_exec_pppd(int *);
static int mhf_ok_pppd(int *);
static int mhf_nok_pppd(int *);
static int mhf_exec_ipup(int *);
static int mhf_exec_wannabe_changed(int *);
static int mhf_ok_wannabe_changed(int *);
static int mhf_nok_wannabe_changed(int *);
static int kill_pppd(int);
static int mhf_exec_announce(int *);
static int mhf_exec_qtest(int *);
static int mhf_ok_qtest(int *);
static int mhf_nok_qtest(int *);
static int mhf_qtest_response(int *);
static int mhf_exec_mail(int *);
static int mhf_exec_misc(int *);
static int mhf_nok_mail(int *);
static int mhf_ok_mail(int *);
static int mhf_exec_news(int *);
static int mhf_nok_news(int *);
static int mhf_ok_news(int *);
static int mhf_exec_usecnt(int *);
static int mhf_ok_usecnt(int *);
static int mhf_nok_usecnt(int *);
static int mhf_usecnt_response(int *);
static int mhf_set_debug(int *);
static int mhf_set_quality(int *);
static int mhf_set_idlepars(int *);
static int mhf_set_quit(int *);
static int mhf_set_donews(int *);
static int mhf_unset_donews(int *);
static int mhf_hangup(int *);
static int mhf_exec_ipdown(int *);
static int mhf_noaction(int *);
static void init_config(void);
static int gen_config(void);
static int load_config(char *, int);
static int assmf_init(char *, uid_t *, gid_t *, int *); 
static int usage(void);

/*******************************************************************************
*
*   Static Data Definitions
*   
*******************************************************************************/

static char *lock_dir = NULL;			/* locks dir, dflt if null */
static char **global_argvp;			/* for funcs to change cmdln */
static int global_argc;				/* for funcs to change cmdln */
static int reason_down = HUPID_UNSET;
static int idle_oldusecnt = -1;
static unsigned long idle_oldusetim = 0;
static int ppp_interface_no;
static char pppd_cmd[PPPLCD_MAXSTRLEN];
static char chat_cmd[PPPLCD_MAXSTRLEN];
static char announce_cmd[PPPLCD_MAXSTRLEN];
static char wannabe_changed_cmd[PPPLCD_MAXSTRLEN];
static char chatfile[PPPLCD_MAXSTRLEN];
static char qtest_cmd[PPPLCD_MAXSTRLEN];
static char usecnt_cmd[PPPLCD_MAXSTRLEN];
static char news_cmd[PPPLCD_MAXSTRLEN];
static char misc_cmd[PPPLCD_MAXSTRLEN];
static char mail_cmd[PPPLCD_MAXSTRLEN];
static int pppd_debug = 0;
static int pppd_kdebug = 0;
static char port[16];
static char netmask[32];
static int speed;
static int mtu;
static int mru;
static char login[16];
static char password[16];
static char telno[32];
static char *master_config_file;
static int quality_interval;
static int quality_minlevel;
static int idle_timeout;					
static int state_cfgok;
static int flag_officially_up;			/* have we been connected? */
static int flag_wannabe_up;                     /* have we been connected? */
static int state_inipup;			/* in post conn sequence? */
static int flag_exit_when_you_become_interruptable_again;
static int flag_in_connect_sequence;
static struct strchnrec *strchnroot = NULL;	/* chain of chat lines */
static int do_xfer_news_flag;
static int flag_autoreconnect;
static int state_inipup;                        /* in post conn sequence? */
static int state_donenx;                        /* to assess if ipup finished */
static int state_donemx;                        /* to assess if ipup finished */
static uid_t ipc_owner;
static gid_t ipc_group;
static int ipc_mode;
static struct mhflkuprec svrmhf_data[] = {
    { MSGID_EXEC_PPPD,              mhf_exec_pppd                   },
    { MSGID_OK_PPPD,                mhf_ok_pppd                     },
    { MSGID_NOK_PPPD,               mhf_nok_pppd                    },
    { MSGID_SET_QUIT,               mhf_set_quit                    },
    { MSGID_EXEC_IPUP,              mhf_exec_ipup                   },
    { MSGID_HANGUP,                 mhf_hangup                      },
    { MSGID_EXEC_QTEST,             mhf_exec_qtest                  },
    { MSGID_OK_QTEST,               mhf_ok_qtest                    },
    { MSGID_NOK_QTEST,              mhf_nok_qtest                   },
    { MSGID_EXEC_MAIL,              mhf_exec_mail                   },
    { MSGID_OK_MAIL,                mhf_ok_mail                     },
    { MSGID_NOK_MAIL,               mhf_nok_mail                    },
    { MSGID_EXEC_NEWS,              mhf_exec_news                   },
    { MSGID_OK_NEWS,                mhf_ok_news                     },
    { MSGID_NOK_NEWS,               mhf_nok_news                    },
    { MSGID_EXEC_IPDOWN,            mhf_exec_ipdown                 },
    { MSGID_NOACTION,               mhf_noaction                    },
    { MSGID_INFO_REQ,               mhf_info_request                },
    { MSGID_SET_QUALITY,            mhf_set_quality                 },
    { MSGID_SET_DEBUG,              mhf_set_debug                   },
    { MSGID_SET_DONEWS,             mhf_set_donews                  },
    { MSGID_SET_IDLEPARS,           mhf_set_idlepars                },
    { MSGID_EXEC_USECNT,            mhf_exec_usecnt                 },
    { MSGID_OK_USECNT,              mhf_ok_usecnt                   },
    { MSGID_NOK_USECNT,             mhf_nok_usecnt                  },
    { MSGID_EXEC_QTEST,             mhf_exec_qtest                  },
    { MSGID_OK_QTEST,               mhf_ok_qtest                    },
    { MSGID_NOK_QTEST,              mhf_nok_qtest                   },
    { MSGID_UNSET_DONEWS,           mhf_unset_donews                },
    { MSGID_LOAD_CONFIG,            mhf_load_config                 },
    { MSGID_GEN_CONFIG,             mhf_gen_config                  },
    { MSGID_SET_AUTORECONNECT,      mhf_set_autoreconnect           },
    { MSGID_UNSET_AUTORECONNECT,    mhf_unset_autoreconnect         },
    { MSGID_QTEST_RESPONSE,         mhf_qtest_response              },
    { MSGID_EXEC_MISC,              mhf_exec_misc                   },
    { MSGID_EXEC_ANNOUNCE,          mhf_exec_announce               },
    { MSGID_EXEC_WANNABE_CHANGED,   mhf_exec_wannabe_changed        },
    { MSGID_OK_WANNABE_CHANGED,     mhf_ok_wannabe_changed          },
    { MSGID_NOK_WANNABE_CHANGED,    mhf_nok_wannabe_changed         },
    { MSGID_USECNT_RESPONSE,        mhf_usecnt_response             },
    { MSGID_PSEUDO_LAST,            NULL                            }
};
static struct varspcrec *ppplcd_varspc = NULL;

/*******************************************************************************
*
*   Global Data Definitions
*   
*******************************************************************************/

/*******************************************************************************
*
*   Functions: main() and usage() and gen_lockfile_name()
*   
*******************************************************************************/

/*
 *  We make usage() return an int in the declaration, although it actually
 *  returns nothing, so that callers can use a construct like:
 *  
 *  (argc == 3) || usage();
 *  
 *  which would otherwise return an error.
 */

static int usage()
{
    debug(DBG_FUNCS, "usage: sof");

    fprintf(stderr, "Usage: %s [ -v | -d <level> ] [ -n ] [ -i <ifno> ] [ -V ] <cfgfile>\n", progname);
    exit(EXIT_FAILURE);
}

main(
int argc,
char *argv[])
{
    pid_t pid;
    pid_t locking_pid;
    int rc;
    int detach_flag;
    char *cp;

    /* 
     *  save argv into global var, so that functions can modify the command
     *  line displayed by 'ps' etc.
     */

    global_argvp = &argv[0];
    global_argc = argc;

    progname = mybasename(argv[0], "");
   
    detach_flag = 1;
    ppp_interface_no = IFNO_UNSET;

    while (argc>1 && argv[1][0] == '-') {
        if (strcmp(argv[1], "-n") == 0)
            detach_flag = 0;

        else if (strcmp(argv[1], "-V") ==0) {
            printf("%s version %s\n", progname, patchlevel);
            exit(EXIT_SUCCESS);

        } else if (strcmp(argv[1], "-d") == 0) {
            (argc<3) && usage();
            (sscanf(argv[2], "%lu", &debug_level)!=1) && usage();
            argc--; argv++;

        } else if (strcmp(argv[1], "-i") == 0) {
            (argc<3) && usage();
            (sscanf(argv[2], "%d", &ppp_interface_no)!=1) && usage();
            argc--; argv++;

        } else 
            (void) usage();

        argv++;
        argc--;
    }
    
    if (argc != 2)
        (void) usage();

    if (!detach_flag)
        info("process not detached");
    else if ((pid=fork()) < 0)
        error(strerror(errno));
    else if (pid > 0)
        exit(EXIT_SUCCESS);
    else {
        i_am_a_daemon = TRUE;
        putenv("I_AM_A_DAEMON=true");		/* for child scripts */
    }

    /* ensure shell breaks don't kill us */
    /*@-unrecog@*/
    setpgrp();
    /*@=unrecog@*/

    debug(DBG_FUNCS, "main: sof (proper)");

    /* 
     *  The server should reap zombies but not be bothered about return codes, 
     *  which will be handled by the wrapper. INT and TERM should be handled
     *  gracefully. Note signal handlers should be set up *BEFORE* calling
     *  the my_lock() function.
     */

    debug(DBG_SIGEXEC, "main: setting up signal handlers");
    signal(SIGCHLD, sigchld_handler);
    signal(SIGINT, genericsighandler);
    signal(SIGTERM, genericsighandler);

    if ((locking_pid=my_lock(NULL, gen_lockfile_name)) > 0)
        error("running already (pid=%d)", locking_pid);
    else if (locking_pid < 0)
	error("can't create lockfile: %s", strerror(errno));

    smf_shutdown();

    /* 
     *  Load config files, though failure to do so is not a terminal error.
     *  We just note the return code and prevent pppd being run if it fails.
     *  The user may have another go at loading it up again later.
     *  Note that the config must be loaded to get the ipc perms etc before
     *  the mesage queue is created. But that the ownership of an existing
     *  message queue will not be affected if the config is reloaded.
     */

    if ((rc=smf_init(SMS_MCMODE_SERVER|SMS_MCMODE_CLIENT, assmf_init, argv[1])))
	error("state machine initialisation failed (errcode=%d)", rc);
    
    /* TEST!!! */
    if ((cp=lookup(ppplcd_varspc, "VAR2")) == NULL)
	warning("variable not found");
    else
	info("var has value %s", cp);

    info("ready");
    smf_engine(MSGTO_PPPLCD, svrmsginfo_data, svrmhf_data);

    /*
     *  Graceful exit code
     */

    smf_shutdown();
    my_unlock(NULL, gen_lockfile_name);
    exit(EXIT_SUCCESS);
}

int gen_lockfile_name(
char *lockfile,
char *lockwhat)
{
					/* lockwhat is set to NULL */
    sprintf(lockfile, "%s/%s.pid", LOCK_DIR, progname);
    return(0);
}

/*******************************************************************************
*
*   Functions: Signal Handlers
*   
*******************************************************************************/

static void sigchld_handler(
/*@unused@*/
int signumber)
{
    signal(SIGCHLD, SIG_IGN);
    debug(DBG_FUNCS, "sigchld_handler: sof");
    (void) wait(NULL);
    debug(DBG_SIGEXEC, "sigchld_handler: done wait()");
    signal(SIGCHLD, sigchld_handler);
}

/******************************************************************************
*
*  Functions: Message Handlers
*
******************************************************************************/

static int mhf_load_config(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_load_config: sof");
    load_config("master.cfg", 0);
}

static int mhf_gen_config(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_gen_config: sof");
    gen_config();
}

static int mhf_set_autoreconnect(
int *notusedp)
{
    flag_autoreconnect = TRUE;
}

static int mhf_unset_autoreconnect(
int *notusedp)
{
    flag_autoreconnect = FALSE;
}

static int mhf_info_request(
int *parp)
{
    int info_requester = *parp;
    int parcnt;
    int *mp;
    int rc;

    debug(DBG_FUNCS, "mhf_info_request: sof");

    parcnt = (svrmsginfo_data+smf_msginfo(svrmsginfo_data, MSGID_INFO_DATA))->argc;
    if (parcnt == 0) {
        internal("mhf_info_request: lookup says MSGID_INFO_DATA has no pars");
    } else if ((mp=(int *) calloc(sizeof(int), parcnt)) == NULL)
        error("calloc: %s", strerror(errno));

    /*
     *  Read/Write parameters
     */

    *(mp+0)  = flag_wannabe_up;
    *(mp+1)  = smf_setquit(SMS_VAR_READ);
    *(mp+2)  = do_xfer_news_flag;
    *(mp+3)  = flag_autoreconnect;
    *(mp+4)  = debug_level;
    *(mp+5)  = idle_timeout;
    *(mp+6)  = quality_minlevel;
    *(mp+7)  = quality_interval;
    *(mp+8)  = INFID_RESERVED;
    *(mp+9)  = INFID_RESERVED;
    *(mp+10) = INFID_RESERVED;
    *(mp+11) = INFID_RESERVED;
    *(mp+12) = INFID_RESERVED;
    *(mp+13) = INFID_RESERVED;
    *(mp+14) = INFID_RESERVED;
    *(mp+15) = INFID_RESERVED;
    *(mp+16) = INFID_RESERVED;
    *(mp+17) = INFID_RESERVED;
    *(mp+18) = INFID_RESERVED;
    *(mp+19) = INFID_RESERVED;

    /*
     *  Read-only parameters
     */

    *(mp+20) = flag_officially_up;
    *(mp+21) = state_cfgok;
    *(mp+22) = state_donemx;
    *(mp+23) = state_donenx;
    *(mp+24) = state_inipup;
    *(mp+25) = ipc_mode;
    *(mp+26) = ipc_owner;
    *(mp+27) = ipc_group;
    *(mp+28) = INFID_RESERVED;
    *(mp+29) = INFID_RESERVED;
    *(mp+30) = INFID_RESERVED;
    *(mp+31) = INFID_RESERVED;
    *(mp+32) = INFID_RESERVED;
    *(mp+33) = INFID_RESERVED;
    *(mp+34) = INFID_RESERVED;
    *(mp+35) = INFID_RESERVED;
    *(mp+36) = INFID_RESERVED;
    *(mp+37) = INFID_RESERVED;
    *(mp+38) = INFID_RESERVED;
    *(mp+39) = INFID_RESERVED;

    if (rc=smf_submit(svrmsginfo_data, info_requester, time(NULL), MSGID_INFO_DATA, mp, SMS_SUBMIT_QUEUE))
        error("IPC queue submit failed");
    free(mp);
}

static int mhf_exec_pppd(
int *notusedp)
{
    char cmdbuf[512];
    int *intp;

    debug(DBG_FUNCS, "mhf_exec_pppd: sof");
    
    if (flag_in_connect_sequence) {
	warning("internal lock set");
	return(1);
    } else
	flag_in_connect_sequence = TRUE;

    if (!state_cfgok) {
        warning("config has not yet been successfully loaded");
	flag_in_connect_sequence = FALSE;
        return;
    }

    if (!flag_wannabe_up) {
	flag_wannabe_up = TRUE;
        if (*wannabe_changed_cmd != '\0') {
            if ((intp = (int *) calloc(sizeof(int), 1)) == NULL)
                error("calloc: %s", strerror(errno));
            *intp = 1;
            smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_WANNABE_CHANGED, intp, SMS_SUBMIT_DIRECT);
        }
    }

    flag_exit_when_you_become_interruptable_again = FALSE;
    /* sprintf(cmdbuf, "%s %s %d connect \"%s -v -f %s\" call %s crtscts defaultroute lock netmask %s noipdefault asyncmap 0x00000000 mru %d mtu %d lcp-echo-interval 180 -detach lcp-echo-interval 0 kdebug %d%s", 
            pppd_cmd, port, speed, chat_cmd, chatfile, "eso-dial", netmask, mru, mtu, pppd_kdebug, pppd_debug ? " debug" : ""); */
    substitute(cmdbuf, lookup(ppplcd_varspc, "pppd2"), ppplcd_varspc);
    reason_down = HUPID_UNSET;
    smf_fkwsmrc(cmdbuf, MSGTO_PPPLCD, MSGID_OK_PPPD, MSGID_NOK_PPPD, svrmsginfo_data);
}

static int mhf_exec_wannabe_changed(
int *statusp)
{
    char envbuf[16];

    sprintf(envbuf, "%d", *statusp);
    setenv("PPPLCD_WANNABE", envbuf, TRUE);
    smf_fkwsmrc(wannabe_changed_cmd, MSGTO_PPPLCD, MSGID_OK_WANNABE_CHANGED, MSGID_NOK_WANNABE_CHANGED, svrmsginfo_data);
}

static int mhf_ok_wannabe_changed(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_ok_wannabe_changed: sof");
}

static int mhf_nok_wannabe_changed(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_wannabe_changed: sof");
    mhf_ok_wannabe_changed(notusedp);
}

static int mhf_exec_announce(
int *annidp)
{
    char cmdbuf[512];
    
    sprintf(cmdbuf, "%s %d", announce_cmd, *annidp);
    smf_fkwsmrc(cmdbuf, MSGTO_PPPLCD, MSGID_NOACTION, MSGID_NOACTION, svrmsginfo_data);
}

static int mhf_ok_pppd(
int *notusedp)
{
    int announce_id;
    int *mp;
    int *intp;

    debug(DBG_FUNCS, "mhf_ok_pppd: sof");

    /*
     *  In the event that the 'HANGUP' message was sent at a time when
     *  pppd *was* interruptable, then this variable will have been set
     *  (how was the killer supposed to know it wasn't uninterruptable?)
     *  and not cleared yet. This is the earliest place to clear it.
     */

    flag_exit_when_you_become_interruptable_again = FALSE;
    
    /*
     *  Same goes for these.
     */

    ppp_interface_no = IFNO_UNSET;
    state_inipup = 0;

    /*
     *  Delete pending use count checks
     */

    if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
        error("calloc: %s", strerror(errno));
    *mp = MSGID_EXEC_USECNT;
    smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_DEL_MSGID, mp, SMS_SUBMIT_DIRECT);

    /*
     *  Delete pending quality checks
     */

    if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
        error("calloc: %s", strerror(errno));
    *mp = MSGID_EXEC_QTEST;
    smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_DEL_MSGID, mp, SMS_SUBMIT_DIRECT);

    if (flag_officially_up) {
        flag_officially_up = FALSE;

        /*
         *  Work out if we should try to reconnect
         */
    
        switch (reason_down) {
            case HUPID_UNSET:		/* remote hangup */
                flag_wannabe_up = flag_autoreconnect;
                break;
            case HUPID_QUALITY:		/* locally detected bad quality */
                flag_wannabe_up = flag_autoreconnect;
                break;
            case HUPID_HANGUP:		/* local hangup */
                flag_wannabe_up = 0;
                break;
            case HUPID_IDLE:		/* locally detected idle */
                flag_wannabe_up = 0;
                break;
        }
	
        /*
         *  Announce down only (we'd only be inside the above 'if', if we
         *  had announced being up. Note that announce_id depends on
         *  the flag_wannabe_up we have just worked out, so the flag_wannabe_up
         *  calculation must come *before* the announce_id calculation.
         */

        switch (reason_down) {
            case HUPID_UNSET:		/* remote hangup */
                announce_id = (flag_wannabe_up) ? ANNID_DOWN_REMOTE_REDIAL : 
			ANNID_DOWN_REMOTE_NOREDIAL;
                break;
            case HUPID_QUALITY:		/* locally detected bad quality */
                announce_id = (flag_wannabe_up) ? ANNID_DOWN_QUALITY_REDIAL : 
			ANNID_DOWN_QUALITY_NOREDIAL;
                break;
            case HUPID_HANGUP:		/* local hangup */
                announce_id = ANNID_DOWN_HANGUP_NOREDIAL;
                break;
            case HUPID_IDLE:		/* locally detected idle */
                announce_id = ANNID_DOWN_IDLE_NOREDIAL;
                break;
            default:
                internal("(%s,%d) unexpected down reason: %d", __FILE__, 
				__LINE__, reason_down);
                break;
	}

        if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
            error("calloc: %s", strerror(errno));
        *mp = announce_id;
	smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_ANNOUNCE, mp, SMS_SUBMIT_DIRECT);
    }
    
    if (!flag_wannabe_up && *wannabe_changed_cmd != '\0') {
        if ((intp = (int *) calloc(sizeof(int), 1)) == NULL)
            error("calloc: %s", strerror(errno));
        *intp = 0;
        smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_WANNABE_CHANGED, intp, SMS_SUBMIT_DIRECT);
    }

    /*
     *  If we do want to reconnect then go ahead and do it! 
     */

        flag_in_connect_sequence = FALSE;
    if (flag_wannabe_up)
	smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_PPPD, NULL, SMS_SUBMIT_DIRECT);
}

static int mhf_nok_pppd(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_pppd: sof");
    mhf_ok_pppd(notusedp);
}

static int mhf_exec_ipup(
int *ifnop)
{
    debug(DBG_FUNCS, "mhf_exec_ipup: sof");
    ppp_interface_no = *ifnop;		/* note interface number */
    if (flag_exit_when_you_become_interruptable_again) {
        flag_exit_when_you_become_interruptable_again = FALSE;
	return(kill_pppd(ppp_interface_no));
    }
    state_inipup = 1;
    return(ipup_part1());
}

static int mhf_exec_qtest(
int *notusedp)
{
    char cmdbuf[PPPLCD_MAXSTRLEN];

    debug(DBG_FUNCS, "mhf_exec_qtest: sof");
    smf_fkwsmrc(qtest_cmd, MSGTO_PPPLCD, MSGID_OK_QTEST, MSGID_NOK_QTEST, svrmsginfo_data);
}

static int mhf_ok_qtest(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_ok_qtest: sof");

    /* 
     *  qualitycheck_flag is likely to be on, hey!, or why would we be here in 
     *  the first place? but it could have been turned off while the test was
     *  running, so we check again.
     */

    if (quality_interval && quality_minlevel && flag_officially_up && flag_wannabe_up) {
       debug(DBG_QUALIDLE, "mhf_ok_qtest: requeuing qtest check for %d secs", quality_interval);
       smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL)+quality_interval, MSGID_EXEC_QTEST, NULL, SMS_SUBMIT_DIRECT);
    } else
       debug(DBG_QUALIDLE, "mhf_ok_qtest: NOT requeuing qtest");
}

static int mhf_nok_qtest(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_qtest: sof");
    mhf_ok_qtest(notusedp);
}

static int mhf_qtest_response(
int *qualityp)
{
    if (*qualityp < quality_minlevel) {
        reason_down = HUPID_QUALITY;
        return(kill_pppd(ppp_interface_no));

    } else if (state_inipup && !flag_officially_up)
        return(ipup_part3());
}

static int mhf_exec_mail(
int *notusedp)
{
    debug(DBG_FUNCS|DBG_SPECIAL1, "mhf_exec_mail: sof");
    smf_fkwsmrc(mail_cmd, MSGTO_PPPLCD, MSGID_OK_MAIL, MSGID_NOK_MAIL, svrmsginfo_data);
}

static int mhf_nok_mail(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_mail: sof");
    mhf_ok_mail(notusedp);
}

static int mhf_ok_mail(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_ok_mail: sof");
    if (!state_inipup) return;
    state_donemx = 1;

    ipup_part4();
}

static int mhf_exec_misc(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_exec_misc: sof");
    smf_fkwsmrc(misc_cmd, MSGTO_PPPLCD, MSGID_NOACTION, MSGID_NOACTION, svrmsginfo_data);
}

static int mhf_exec_news(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_exec_news: sof");
    smf_fkwsmrc(news_cmd, MSGTO_PPPLCD, MSGID_OK_NEWS, MSGID_NOK_NEWS, svrmsginfo_data);
}

static int mhf_nok_news(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_news: sof");
    mhf_ok_news(notusedp);
}

static int mhf_ok_news(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_ok_news: sof");
    if (!state_inipup) return;
    state_donenx = 1;

    ipup_part4();
}

static int mhf_exec_usecnt(
int *parp)
{
    char cmdbuf[512];
    
    debug(DBG_FUNCS, "mhf_exec_usecnt: sof");
    sprintf(cmdbuf, "%s ppp%d", usecnt_cmd, *parp);
    smf_fkwsmrc(cmdbuf, MSGTO_PPPLCD, MSGID_OK_USECNT, MSGID_NOK_USECNT, svrmsginfo_data);
}

static int mhf_ok_usecnt(
int *notusedp)
{
    int *ifnop;

    debug(DBG_FUNCS, "mhf_ok_usecnt: sof");

    if (idle_timeout && flag_officially_up && flag_wannabe_up) {
       debug(DBG_QUALIDLE, "mhf_ok_usecnt: requeuing idle check for %d secs", idle_timeout/4);
       if ((ifnop=(int *) calloc(sizeof(int), 1)) == NULL)
           error("calloc: %s", strerror(errno));
       *ifnop = ppp_interface_no;
       smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL)+idle_timeout/4, MSGID_EXEC_USECNT, ifnop, SMS_SUBMIT_DIRECT);
    } else 
       debug(DBG_QUALIDLE, "mhf_ok_usecnt: NOT requeuing idle check");
}

static int mhf_nok_usecnt(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_nok_usecnt: sof");
    mhf_ok_usecnt(notusedp);
}

static int mhf_usecnt_response(
int *usecountp)
{
    /*
     *              countrisen          !countrisen
     *              -----------------------------------
     *   expired  | update last count   kill with announce
     *   !expired | update last count   do nothing
     */

    if (*usecountp == idle_oldusecnt && time(NULL) > idle_oldusetim + 
		    idle_timeout) {
        debug(DBG_QUALIDLE, "mhf_exec_usecnt: idle and limit expired");
        reason_down = HUPID_IDLE;
        return(kill_pppd(ppp_interface_no));

    } else if (*usecountp == idle_oldusecnt) {
        debug(DBG_QUALIDLE, "mhf_exec_usecnt: idle but limit not expired yet");
        return(0);

    } else {
        debug(DBG_QUALIDLE, "mhf_exec_usecnt: not idle");
        idle_oldusetim = time(NULL);
        idle_oldusecnt = *usecountp;
        return(0);
    }
}

static int mhf_set_debug(
int *debug_levelp)
{
    debug(DBG_FUNCS, "mhf_set_debug: sof");

    /*
     *  Note that the mhf functions currently take integers as parameters
     *  and that debug_level is a long. Really the parameter should be the
     *  address of a union of int, unsigned long and char *. And the
     *  mhf functions should extract the bit they want. But we'll leave
     *  that for the time being.
     */

    debug_level = (unsigned long) *debug_levelp;
}

static int mhf_set_quality(
int *new_qualityp)
{
    int *mp;

    debug(DBG_FUNCS, "mhf_set_quality: sof");

    /*
     *  Delete pending quality checks
     */

    if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
        error("calloc: %s", strerror(errno));
    *mp = MSGID_EXEC_QTEST;
    smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_DEL_MSGID, mp, SMS_SUBMIT_DIRECT);

    quality_minlevel = *new_qualityp;
    quality_interval = *(new_qualityp+1);

    if (quality_minlevel > 0 && quality_interval > 0 && flag_officially_up && flag_wannabe_up)
        smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_QTEST, NULL, SMS_SUBMIT_DIRECT);
}

static int mhf_set_idlepars(
int *idle_timeoutp)
{
    int i;
    int *ifnop;
    int *mp;

    debug(DBG_FUNCS, "mhf_set_idlepars: sof");

    /*
     *  Delete pending use count checks
     */

    if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
        error("calloc: %s", strerror(errno));
    *mp = MSGID_EXEC_USECNT;
    smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_DEL_MSGID, mp, SMS_SUBMIT_DIRECT);

    if (*idle_timeoutp > 0 && idle_timeout == 0) {
        idle_oldusecnt = -1;
        idle_oldusetim = 0;
    }

    idle_timeout = *idle_timeoutp;

    if (idle_timeout > 0 && flag_officially_up && flag_wannabe_up) {
        if ((ifnop=(int *) calloc(sizeof(int), 1)) == NULL)
            error("calloc: %s", strerror(errno));
        *ifnop = ppp_interface_no;
        smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_USECNT, ifnop, SMS_SUBMIT_DIRECT);
    }
}

static int mhf_set_quit(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_set_quit: sof");

    smf_setquit(SMS_VAR_TOGGLE);
}

static int mhf_set_donews(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_set_donews: sof");

    do_xfer_news_flag = 1;
}

static int mhf_unset_donews(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_unset_donews: sof");

    do_xfer_news_flag = 0;
}

static int mhf_hangup(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_hangup: sof");
	    
    flag_exit_when_you_become_interruptable_again = TRUE;
    flag_wannabe_up = FALSE;

    if (flag_officially_up) {
        reason_down = HUPID_HANGUP;
        return(kill_pppd(ppp_interface_no));
    }
    
    return(0);
}

static int mhf_exec_ipdown(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_exec_ipdown: sof");

    /* 
     *  note ppp_interface_no is cleared when pppd exits - it's more certain
     *  to be done there than here (e.g. kill -9 on running pppd will not
     *  result in this function getting called.
     */

}

static int mhf_noaction(
int *notusedp)
{
    debug(DBG_FUNCS, "mhf_noaction: sof");
}

/******************************************************************************
*
*  'QUICK' FUNCTIONS
*
*******************************************************************************/

static int ipup_part1()
{
    int *intp;

    debug(DBG_FUNCS, "ipup_part1 (placeholder): sof");

    return(ipup_part2());
}

static int ipup_part2()
{
    debug(DBG_FUNCS, "ipup_part2 (quality tester): sof");

    if (quality_interval && quality_minlevel)
        return(smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_QTEST, NULL, SMS_SUBMIT_DIRECT));
    else
        return(ipup_part3());
}

static int ipup_part3()
{
    char cmdbuf[PPPLCD_MAXSTRLEN];
    int *mp;
    int *ifnop;

    debug(DBG_FUNCS, "ipup_part3 (announce, news, mail, misc): sof");

    /*
     *  Announce it's up!
     */

    if ((mp=(int *) calloc(sizeof(int), 1)) == NULL)
        error("calloc: %s", strerror(errno));
    *mp = ANNID_UP;
    smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_ANNOUNCE, mp, SMS_SUBMIT_DIRECT);
    flag_officially_up = TRUE;
    
    /*
     *  Do mail, news, misc and idle checks concurrently
     */

    if (*misc_cmd != '\0')
        smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_MISC, NULL, SMS_SUBMIT_DIRECT);

    if (idle_timeout) {
        idle_oldusecnt = -1;
        idle_oldusetim = 0;
        if ((ifnop=(int *) calloc(sizeof(int), 1)) == NULL)
            error("calloc: %s", strerror(errno));
        *ifnop = ppp_interface_no;
        smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_USECNT, ifnop, SMS_SUBMIT_DIRECT);
    }

    state_donenx = state_donemx = 0;
    if (*mail_cmd == '\0' && (*news_cmd == '\0' || !do_xfer_news_flag))
        ipup_part4();
    else {
        if (*news_cmd != '\0' && do_xfer_news_flag) 
            smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_NEWS, NULL, SMS_SUBMIT_DIRECT);
        if (*mail_cmd != '\0')
            smf_submit(svrmsginfo_data, MSGTO_PPPLCD, time(NULL), MSGID_EXEC_MAIL, NULL, SMS_SUBMIT_DIRECT);
    }
}

static int ipup_part4()
{
    debug(DBG_FUNCS|DBG_SPECIAL1, "ipup_part4 (news & mail exit union): sof");
    if ((*mail_cmd != '\0' && !state_donemx) || (*news_cmd != '\0' && do_xfer_news_flag && !state_donenx))
        return;

    debug(DBG_FUNCS|DBG_SPECIAL1, "ipup_part4 (placeholder): post-exclusions");
    state_inipup = 0;
}

/******************************************************************************
* 
*   APPLICATION-SPECIFIC STATE-MACHINE INTERFACE FUNCTIONS
*   
******************************************************************************/

/* 
 *  Application specific state machine initialisation function
 */

static int assmf_init(
char *master_config_file,
uid_t *ipc_owner_p,
gid_t *ipc_group_p,
int *ipc_mode_p)
{
    do_xfer_news_flag = 1;
    state_inipup = 0;
    state_cfgok  = 0;
			
    if (ppp_interface_no == IFNO_UNSET) {
        flag_officially_up = FALSE;
        flag_wannabe_up = FALSE;
        flag_in_connect_sequence = FALSE;
    } else {
        flag_officially_up = TRUE;
        flag_wannabe_up = TRUE;
        flag_in_connect_sequence = TRUE;
    }

    /*
     *  Code removed: we can no longer derive flag_officially_up and 
     *  flag_wannabe_up.  But we could have a command to mean "I'm telling you, 
     *  the connection is currently UP."
     */

    if (load_config(master_config_file, 0) != 0) {
	warning("config file load failed");
        return(1);
    } 
    
    if (gen_config() != 0) {
        warning("config file generate failed");
        return(2);
    }

    *ipc_owner_p = ipc_owner;
    *ipc_group_p = ipc_group;
    *ipc_mode_p  = ipc_mode;

    return(0);
}

static void init_config()
{
    struct strchnrec *linkaddr, *tmp;

    debug(DBG_FUNCS, "init_config: sof");

    sprintf(chatfile, "%s/%s.%d.chat", TMP_DIR, progname, (int) getpid());

    /*
     *  These are all the things that are necessary! Optional ones should
     *  be set in main before the options. they are tested below in 
     *  gen_config().
     */

    *pppd_cmd = '\0';
    *chat_cmd = '\0';
    idle_timeout = KWN_UNSET;
    flag_autoreconnect = KWN_UNSET;
    quality_interval = KWN_UNSET;
    quality_minlevel = KWN_UNSET;
    *announce_cmd = '\0';
    *wannabe_changed_cmd = '\0';
    *qtest_cmd = '\0';
    *usecnt_cmd = '\0';
    *news_cmd = '\0';
    *misc_cmd = '\0';
    *mail_cmd = '\0';
    *port = '\0';
    *netmask = '\0';
    speed = KWN_UNSET;
    mtu = KWN_UNSET;
    mru = KWN_UNSET;
    ipc_mode = KWN_UNSET;
    ipc_owner = KWN_UNSET;
    ipc_group = KWN_UNSET;
    *login = '\0';
    *password = '\0';
    *telno = '\0';
    debug(DBG_IGNORE, "init_config: removing old chatlines");
    /*@-compdestroy@*/
    for (linkaddr=strchnroot; linkaddr!=NULL; linkaddr=tmp) {
        free(linkaddr->str);
        tmp = linkaddr->nxt;
        free(linkaddr);
    }
    /*@=compdestroy@*/
    strchnroot = NULL;
    state_cfgok = 0;
}

static int load_config(
char *fname,
int level)
{
    FILE *fp;
    char linebuf[PPPLCD_MAXSTRLEN];
    int lineno;
    int rc;
    char *endcp, *valcp, *colcp, *cmdcp;
    struct strchnrec **linkaddrp;
    struct passwd *pwp;
    /*@-mustfree@*/ struct group *grpp;
    char *val, *var;

    debug(DBG_FUNCS, "load_config: sof");

    /*
     *  Free up old storage of chatlines
     */

    if (level == 0)
        init_config();
        
    if ((fp=fopen(fname, "r")) == NULL) {
        warning("can't open %s", fname);
        return(1);
    }

    for (lineno=1; fgets(linebuf, (int) sizeof(linebuf), fp) != NULL; lineno++) {
        
        /* find the proper beginning of the line */
        for (cmdcp=linebuf; *cmdcp && (*cmdcp=='\t' || *cmdcp==' '); cmdcp++)
            ;
        if (!*cmdcp) {
            continue;
        } else if (*cmdcp == '\n') {
            continue;
        } else if (*cmdcp == '#') {
            continue;
        } 

        /* terminate the first word */
        for (endcp=cmdcp; *endcp && *endcp!='\n' && *endcp!=':' && *endcp!=' ' && *endcp!='\t'; endcp++)
            ;
        if (*endcp == '\n' || !*endcp) {
            warning("no colon in line %d of file %s", lineno, fname);
            (void) fclose(fp);
            return(2);
        } else if (endcp == cmdcp) {
            warning("no command in line %d of file %s", lineno, fname);
            (void) fclose(fp);
            return(3);
        }

        /* but locate the colon first, 'cos terminating the first word may overwrite the colon 
           and then we've lost it! */
        for (colcp=endcp; *colcp && *colcp !=':'; colcp++)
            ;
        if (!*colcp) {
            warning("no colon in line %d of file %s", lineno, fname);
            (void) fclose(fp);
            return(4);
        }
        /* now go back and terminate the word */
        *endcp = '\0';

        /* find the first letter of the value */
        for (valcp=colcp+1; *valcp && (*valcp=='\n' || *valcp=='\t' || *valcp==' '); valcp++)
            ;
        if (!*valcp) {
            warning("command without value at line %d of file %s", lineno, fname);
            (void) fclose(fp);
            return(5);
        }
        
        /* finally remove any trailing whitespace */
        for (endcp=valcp+strlen(valcp)-1; endcp>valcp && (*endcp==' ' || *endcp=='\t' || *endcp=='\n'); endcp--)  {
            ;
        }
        *(endcp+1) = '\0';
       
        /*
         *  Here list all optional and required config file entries
         */

        if (strcmp(cmdcp, KW_INCLUDE) == 0) {
            if ((rc=load_config(valcp, level+1)) != 0) {
                (void) fclose(fp);
                return(rc);
            }

        } else if (strcmp(cmdcp, KW_COMMAND_UNIX_PPPD) == 0) {
            strcpy(pppd_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_UNIX_CHAT) == 0) {
            strcpy(chat_cmd, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_PPPD_DEBUG) == 0) {
            pppd_debug = atoi(valcp);

        } else if (strcmp(cmdcp, KW_SETTING_PPPD_KDEBUG) == 0) {
            pppd_kdebug = atoi(valcp);

        } else if (strcmp(cmdcp, KW_SETTING_MISC_TIMEOUT_IDLE) == 0) {
            idle_timeout = atoi(valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_ANNOUNCE) == 0) {
            strcpy(announce_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_WANNABECHANGED) == 0) {
            strcpy(wannabe_changed_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_QUALITYTEST) == 0) {
            strcpy(qtest_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_USECOUNT) == 0) {
            strcpy(usecnt_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_MISC) == 0) {
            strcpy(misc_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_XFER_NEWS) == 0) {
            strcpy(news_cmd, valcp);

        } else if (strcmp(cmdcp, KW_COMMAND_PPPLCD_XFER_MAIL) == 0) {
            strcpy(mail_cmd, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_CONNECT_LOGIN) == 0) {
            strcpy(login, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_CONNECT_PASSWORD) == 0) {
            strcpy(password, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_CONNECT_PHONENUMBER) == 0) {
            strcpy(telno, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_IP_NETMASK) == 0) {
            strcpy(netmask, valcp);

        } else if (strcmp(cmdcp, KW_ASSIGN) == 0) {
            var=strtok(valcp, " \t");
            val=strtok(NULL, " \t");
	    debug(DBG_VARSPC, "load_config: found assign in config file (%s=%s)", var, val);
            if (assign(&ppplcd_varspc, var, val) != 0) 
		error("assignment failed");

        } else if (strcmp(cmdcp, KW_SETTING_IPC_MODE) == 0) {
            if (sscanf(valcp, "%i", &ipc_mode) != 1) {
                warning("%s: definition invalid", KW_SETTING_IPC_MODE);
                (void) fclose(fp);
                return(10);
            }

        } else if (strcmp(cmdcp, KW_SETTING_IPC_OWNER) == 0) {
            if ((pwp=getpwnam(valcp)) != NULL)
                ipc_owner = pwp->pw_uid;

        } else if (strcmp(cmdcp, KW_SETTING_IPC_GROUP) == 0) {

            /* getgrnam(3) doesn't document if pointer needs user-freeing */
            if ((grpp=getgrnam(valcp)) != NULL)
                ipc_group = grpp->gr_gid;

        } else if (strcmp(cmdcp, KW_SETTING_MISC_QUALITY) == 0) {
            if (sscanf(valcp, "%d %d", &quality_minlevel, &quality_interval) != 2) {
                warning("%s: definition invalid", KW_SETTING_MISC_QUALITY);
                (void) fclose(fp);
                return(10);
            }

        } else if (strcmp(cmdcp, KW_SETTING_DEVICE_MODEM_DEVICE) == 0) {
            strcpy(port, valcp);

        } else if (strcmp(cmdcp, KW_SETTING_DEVICE_MODEM_SPEED) == 0) {
            speed = atoi(valcp);

        } else if (strcmp(cmdcp, KW_SETTING_IP_MTU) == 0) {
            mtu = atoi(valcp);

        } else if (strcmp(cmdcp, KW_SETTING_IP_MRU) == 0) {
            mru = atoi(valcp);

        } else if (strcmp(cmdcp, KW_SETTING_MISC_AUTORECONNECT) == 0) {
            flag_autoreconnect = atoi(valcp);

        } else if (strcmp(cmdcp, KW_CHATLINE) == 0) {
            for (linkaddrp=&strchnroot; *linkaddrp!=NULL; linkaddrp=&(*linkaddrp)->nxt)
                ;
            if ((*linkaddrp=(struct strchnrec *) malloc(sizeof(struct strchnrec))) == NULL)
                internal("(%s,%d) malloc failed");
            /*@-unrecog@*/
            if (((*linkaddrp)->str = strdup(valcp)) == NULL)
                /*@=unrecog@*/
                internal("(%s,%d) malloc failed");
            (*linkaddrp)->nxt = NULL;

        } else {
            warning("invalid command '%s' at line %d of file %s", cmdcp, lineno, fname);
            (void) fclose(fp);
            return(6);
        }
    }

    (void) fclose(fp);
    return(0);
}
    

static int gen_config()
{
    static FILE *chat_fp;
    struct strchnrec *linkaddr;
    char valbuf[PPPLCD_MAXSTRLEN];
    char *cp;
    mode_t old_umask;


    debug(DBG_FUNCS, "gen_config: sof");
    state_cfgok = 0;
    old_umask = (mode_t) umask(077);
    delonexit(chatfile);
    if ((chat_fp=fopen(chatfile, "w")) == NULL) {
        warning("can't open %s: %s", chatfile, strerror(errno));
        return(1);
    }
    (void) umask(old_umask);

    /*
     *  Here check all required pars, set to special values in init_config()
     */

    if (!*pppd_cmd) {
        warning("%s: not defined", KW_COMMAND_UNIX_PPPD);
        return(1);
    } else if (!*chat_cmd) {
        warning("%s: not defined", KW_COMMAND_UNIX_CHAT);
        return(1);
    } 
    
    if (idle_timeout == KWN_UNSET) {
        warning("%s: not defined", KW_SETTING_MISC_TIMEOUT_IDLE);
        return(1);
    } else if (!*qtest_cmd) {
        warning("%s: not defined", KW_COMMAND_PPPLCD_QUALITYTEST);
        return(1);
    } else if (!*usecnt_cmd) {
        warning("%s: not defined", KW_COMMAND_PPPLCD_USECOUNT);
        return(1);
    } else if (!*announce_cmd) {
        warning("%s: not defined", KW_COMMAND_PPPLCD_ANNOUNCE);
        return(1);
    } else if (!*netmask) {
        warning("%s: not defined", KW_SETTING_IP_NETMASK);
        return(1);
    } else if (!*port) {
        warning("%s: not defined", KW_SETTING_DEVICE_MODEM_DEVICE);
        return(1);
    } else if (speed == KWN_UNSET) {
        warning("%s: not defined", KW_SETTING_DEVICE_MODEM_SPEED);
        return(1);
    } else if (!*telno) {
        warning("%s: not defined", KW_SETTING_CONNECT_PHONENUMBER);
        return(1);
    } else if (!*password) {
        warning("%s: not defined", KW_SETTING_CONNECT_PASSWORD);
        return(1);
    } else if (!*login) {
        warning("%s: not defined", KW_SETTING_CONNECT_LOGIN);
        return(1);
    } else if (pppd_kdebug < 0 || pppd_kdebug > 7) {
        warning("%s: out of range", KW_SETTING_PPPD_KDEBUG);
        return(1);
    } else if (pppd_debug < 0  || pppd_debug > 1) {
        warning("%s: out of range", KW_SETTING_PPPD_DEBUG);
        return(1);
    } else if (quality_minlevel == KWN_UNSET || quality_interval == KWN_UNSET) {
        warning("%s: not defined", KW_SETTING_MISC_QUALITY);
        return(1);
    } else if (strchnroot == NULL) {
        warning("no chat lines defined in config files");
        return(1);
    } 

    /*
     *  Here generate the chat script
     */

    for (linkaddr=strchnroot; linkaddr!=NULL; linkaddr=linkaddr->nxt) {
        debug(DBG_IGNORE, "gen_config: examining the chat strings");
        strcpy(valbuf, linkaddr->str);
        if ((cp=strstr(valbuf, "%T")) != NULL && !*telno) {
            warning("chatline using %T with no telephone number defined yet");
            (void) fclose(chat_fp);
            return(1);
        } else if (cp != NULL) {
            *(cp+1) = 's';
            fprintf(chat_fp, valbuf, telno);
        } else if ((cp=strstr(valbuf, "%I")) != NULL && idle_timeout == KWN_UNSET) {
            warning("chatline using %I with no idle timeout defined yet");
            (void) fclose(chat_fp);
            return(1);
        } else if (cp != NULL) {
            *(cp+1) = 'd';
            fprintf(chat_fp, valbuf, idle_timeout);
        } else if ((cp=strstr(valbuf, "%L")) != NULL && !*login) {
            warning("chatline using %L with no login defined yet");
            (void) fclose(chat_fp);
            return(1);
        } else if (cp != NULL) {
            *(cp+1) = 's';
            fprintf(chat_fp, valbuf, login);
        } else if ((cp=strstr(valbuf, "%P")) != NULL && !*password) {
            warning("chatline using %P with no password defined yet");
            (void) fclose(chat_fp);
            return(1);
        } else if (cp != NULL) {
            *(cp+1) = 's';
            fprintf(chat_fp, valbuf, password);
        } else {
            fprintf(chat_fp, valbuf);
        }
        fprintf(chat_fp, "\n");
    }
    (void) fclose(chat_fp);


    /*
     *  Here we insert other '%' things into the appropriate command strings.
     */

    /*
     *  Here make any adjustments to values and give any warnings about
     *  ranges etc.
     */

    if (ipc_mode == KWN_UNSET) {
        warning("%s: not defined, defaulting to 0700", KW_SETTING_IPC_MODE);
        ipc_mode = 0700;
    }
    if (ipc_owner == KWN_UNSET) {
        warning("%s: not defined, defaulting to root", KW_SETTING_IPC_OWNER);
        ipc_owner = 0;
    }
    if (ipc_group == KWN_UNSET) {
        warning("%s: not defined, defaulting to root", KW_SETTING_IPC_GROUP);
        ipc_group = 0;
    }
    if (mtu == KWN_UNSET) {
        warning("%s: not defined, defaulting to 576", KW_SETTING_IP_MTU);
        mtu = 576;
    }
    if (mru == KWN_UNSET) {
        warning("%s: not defined, defaulting to 576", KW_SETTING_IP_MRU);
        mru = 576;
    }
    if (flag_autoreconnect == KWN_UNSET) {
        warning("%s: not defined, defaulting", KW_SETTING_MISC_AUTORECONNECT);
        flag_autoreconnect = FALSE;
    }

    if (!*misc_cmd)
        warning("%s: not defined", KW_COMMAND_PPPLCD_MISC);
    if (!*news_cmd)
        warning("%s: not defined", KW_COMMAND_PPPLCD_XFER_NEWS);
    if (!*mail_cmd)
        warning("%s: not defined", KW_COMMAND_PPPLCD_XFER_MAIL);
    if (!*wannabe_changed_cmd)
        warning("%s: not defined", KW_COMMAND_PPPLCD_WANNABECHANGED);

    if (pppd_kdebug && !pppd_debug) {
        warning("pppd-kdebug is set, setting ppp-debug too");
        pppd_debug = 1;
    }

    /*
     *  Flag that config has been successfully loaded - we may go ahead and
     *  connect if we wish.
     */

    state_cfgok = 1;
    return(0);
}

static int kill_pppd(
int ifno)
{
    FILE *fp;
    pid_t pppd_pid;
    char pppd_lock_file[PPPLCD_MAXSTRLEN];

    debug(DBG_FUNCS, "kill_pppd: sof");

    sprintf(pppd_lock_file, PPPD_LOCK_FILE_FMTSTR, ifno);

    if ((fp=fopen(pppd_lock_file, "r")) == NULL) {
        warning("unexpectedly no pppd lock file for ppp%d was found", ifno);
        return(1);
    }

    if (fscanf(fp, "%d", (int *) &pppd_pid) != 1) {
        warning("invalid text in lock file for ppp%d", ifno);
        return(1);
    }

    (void) fclose(fp);

    return(kill(pppd_pid, 15));
}
