#define MAIN
/*@unused@*/
static char *sndmsg_c_rcs_id = "$Header: /diskb/home/alexis/dev/supported/ppplc/bin/RCS/sndmsg.c,v 1.21 1999/05/07 14:41:41 alexis Exp $";

/*******************************************************************************
*
*   System Includes
* 
*******************************************************************************/

#include <stdio.h>			/* for NULL */
#include <stdlib.h>			/* for calloc() */
#include <errno.h>			/* for errno */
#include <string.h>			/* for strerror() */

/*******************************************************************************
*
*   Application Includes
* 
*******************************************************************************/

#include "utils.h"
#include "patchlevel.h"	
#include "ppplc.h"                  	/* for MSGTO_* */
#include "sm.h"				/* smf_*() */
#include "ppplc_msgids.h"		/* for svrmsginfo_data[] */

/*******************************************************************************
*
*   Symbol Definitions
* 
*******************************************************************************/

/*******************************************************************************
*
*   Structure Definitions
* 
*******************************************************************************/

/*******************************************************************************
*
*   Static Functions Forward Declarations
*   
*******************************************************************************/

static int gen_lockfile_name(char *, char *);   /* write filename into buffer */
static int usage(void);

/*******************************************************************************
*
*   Static Data Definitions
*   
*******************************************************************************/

/*******************************************************************************
*
*   Global Data Definitions
*   
*******************************************************************************/

char *progname;

/*******************************************************************************
*
*   Functions: main() and usage() and gen_lockfile_name()
*   
*******************************************************************************/

/*
 *  We make usage() return an int in the declaration, although it actually
 *  returns nothing, so that callers can use a construct like:
 *
 *  (argc == 3) || usage();
 *
 *  which would otherwise return an error.
 */

static int usage()
{
    fprintf(stderr, "Usage: %s -V\n", progname);
    fprintf(stderr, "       %s [ -v | -d <level> ] [ -t <toid> ] [ -q <secs> ] <msgid> [ <msgpars> ] ...\n", progname);
    exit(EXIT_FAILURE);
}

main(
int argc,
char *argv[])
{
    int i;
    int *mp;
    int j;
    int parcnt;
    int msgid;
    unsigned long interval = 0;
    int toid;
    int rc;

    progname = mybasename(argv[0], "");
    toid = MSGTO_PPPLCD;
    debug_level = DBG_WARNING|DBG_ERROR;

    while (argc>1 && argv[1][0] == '-') {
        if (strcmp(argv[1], "-V") == 0) {
            printf("%s version %s\n", progname, patchlevel);
            exit(EXIT_SUCCESS);

        } else if (strcmp(argv[1], "-q") == 0) {
            (argc<3 || sscanf(argv[2], "%lu", &interval)!=1) && usage();
            argc--; argv++;

        } else if (strcmp(argv[1], "-t") == 0) {
            (argc<3 || sscanf(argv[2], "%d", &toid)!=1) && usage();
            argc--; argv++;

        } else if (strcmp(argv[1], "-d") == 0) {
            (argc<3 || sscanf(argv[2], "%lu", &debug_level)!=1) && usage();
            argc--; argv++;

        } else if (strcmp(argv[1], "-v") == 0) {
            debug_level = 3;

        } else
            usage();
        
        argv++;
        argc--;
    }

    if (argc == 1)
        usage();

    /* making the lock should fail! */
    if (my_lock("ppplcd", gen_lockfile_name) == 0) {
        my_unlock("ppplcd", gen_lockfile_name);
        error("server not running!");
    }

    if (smf_init(SMS_MCMODE_CLIENT, NULL, NULL) != 0)
        error("initialisation of client-mode state machine failed");

    for (i=1; i<argc; i++) {
        msgid = atoi(argv[i]);
        parcnt = svrmsginfo_data[smf_msginfo(svrmsginfo_data, msgid)].argc;
        if (parcnt == 0) {
            mp = NULL;
        } else {
            if ((mp=(int *) calloc((size_t) parcnt, sizeof(int))) == NULL) {
                error("calloc: %s", strerror(errno));
                exit(EXIT_FAILURE);
            } 
            for (j=0; j<parcnt; j++) {
                if (i+1 == argc)
                    error("message %d (%s) requires %d parameter%s", msgid, svrmsginfo_data[smf_msginfo(svrmsginfo_data, msgid)].cmt, parcnt, (parcnt>1) ? "s" : "");
                *(mp+j) = atoi(argv[++i]);
            }
        }


        if ((rc=smf_submit(svrmsginfo_data, toid, time(NULL)+interval, msgid, mp, SMS_SUBMIT_QUEUE)) != 0)
            error("can't queue message (%d)", rc);
        if (mp != NULL)
            free(mp);

        debug(DBG_FUNCS, "main: eof");
    }

    return(0);
}

int gen_lockfile_name(
char *lockfile,
char *lockwhat)
{
					/* lockwhat is set to NULL */
    sprintf(lockfile, "%s/%s.pid", LOCK_DIR, "ppplcd");
    return(0);
}
